NXOpen C++ Reference Guide
 All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends Pages
Public Types | Public Member Functions | List of all members
NXOpen::Formboard::FormboardManager Class Reference

Contains information about flattened harness drawing and drafting data for harness manufacturing drawings (Formboard Drawings). More...

Public Types

enum  LegacyComponentOrientationConfidenceLevel { LegacyComponentOrientationConfidenceLevelHigh, LegacyComponentOrientationConfidenceLevelMedium, LegacyComponentOrientationConfidenceLevelLow }
 Returned from FormboardManager::CalculateLegacyComponentClocking as a measure of the confidence in the calculated clocking. More...
 
enum  LegacyComponentOrientationDisplayStyle { LegacyComponentOrientationDisplayStyleNoDisplay, LegacyComponentOrientationDisplayStyleDisplayCurveNormals, LegacyComponentOrientationDisplayStyleDisplaySurface, LegacyComponentOrientationDisplayStyleDisplayAll }
 Used by FormboardManager::CalculateLegacyComponentClocking to display extra information you can use to see how the clocking calculation is made. More...
 

Public Member Functions

void AddPartAs3dHarness (NXOpen::Part *harnessPart)
 Sets the input part as the part containing the potential harnesses to flatten. More...
 
void CalculateLegacyComponentClocking (NXOpen::Assemblies::Component *component1, NXOpen::Assemblies::Component *component2, NXOpen::Formboard::FormboardManager::LegacyComponentOrientationDisplayStyle displayStyle, NXOpen::Vector3d *rotationVector, double *clockingAngle, NXOpen::Formboard::FormboardManager::LegacyComponentOrientationConfidenceLevel *confidenceLevel)
 Calculates the clocking or twist between the two components along their connecting path. More...
 
NXOpen::Formboard::FaceAnnotationBuilderCreateFaceAnnotationBuilder ()
 Creates a NXOpen::Formboard::FaceAnnotationBuilder object for importing CGM or Pattern file geometry and placing it on a drawing sheet or model view. More...
 
NXOpen::Formboard::FlipComponentBuilderCreateFlipComponentBuilder ()
 Creates a NXOpen::Formboard::FlipComponentBuilder object for flipping of formboard component about an axis orthogonal to Z axis to ensure that after flipping component lies in XY plane. More...
 
NXOpen::Formboard::FormboardLayoutBuilderCreateLayoutBuilder ()
 Creates a NXOpen::Formboard::FormboardLayoutBuilder that can flatten and layout new formboard geometry, or modify the layout of existing formboard geometry. More...
 
NXOpen::Formboard::ObjectAttributeReferenceBuilderCreateObjectAttributeReferenceBuilder ()
 Creates a NXOpen::Formboard::ObjectAttributeReferenceBuilder that creates a tabular note object which reads values from the single object selected by the user. More...
 
NXOpen::Formboard::OrientBranchBuilderCreateOrientBranchBuilder ()
 Creates a NXOpen::Formboard::OrientBranchBuilder object for rotating branches in formboard about Z axis. More...
 
NXOpen::Formboard::PathLengthAnnotationBuilderCreatePathLengthAnnotationBuilder (NXOpen::Annotations::Annotation *annotation)
 Creates a NXOpen::Formboard::PathLengthAnnotationBuilder
Created in NX7.5.0. More...
 
NXOpen::Formboard::ShapeSegmentBuilderCreateShapeSegmentBuilder (NXOpen::Routing::ISegment *segment)
 Creates a NXOpen::Formboard::ShapeSegmentBuilder that can shape formboard segments. More...
 
NXOpen::Formboard::UpdateFormboardBuilderCreateUpdateFormboardBuilder ()
 Creates a NXOpen::Formboard::UpdateFormboardBuilder that compares and updates formboard geometry to match a modified master 3D harness. More...
 
void GetFmbdPlaneConstraints (NXOpen::NXObject *fmbdPlane, std::vector< NXOpen::Positioning::ComponentConstraint * > &constraints)
 Gets NXOpen::Positioning::ComponentConstraint which are associated to the formboard plane. More...
 
void HideFormboardConstraints ()
 Hides the formboard constraints. More...
 
bool IsFormboard ()
 Returns whether or not the part containing this NXOpen::Formboard::FormboardManager is actually a Formboard Drawing part file. More...
 
void ShowFormboardConstraints ()
 Shows all of the hidden formboard constraints. More...
 
void StoreHarnessesToFlatten (const std::vector< NXOpen::Routing::Electrical::HarnessDevice * > &harnesses)
 Examines the input list of harnesses and stores information from the harnesses into the part containing this NXOpen::Formboard::FormboardManager . More...
 
tag_t Tag () const
 Returns the tag of this object. More...
 

Detailed Description

Contains information about flattened harness drawing and drafting data for harness manufacturing drawings (Formboard Drawings).


To obtain an instance of this class, refer to NXOpen::Routing::RouteManager

Created in NX7.5.0.

Member Enumeration Documentation

Returned from FormboardManager::CalculateLegacyComponentClocking as a measure of the confidence in the calculated clocking.

Enumerator
LegacyComponentOrientationConfidenceLevelHigh 

High confidence indicates no branches and no severe curvature in the path between the components.

LegacyComponentOrientationConfidenceLevelMedium 

Medium confidence indicates one branch or one curve with severe curvature.

LegacyComponentOrientationConfidenceLevelLow 

Low confidenceindicates more than on branch or more than on curve with severe curvature.

Used by FormboardManager::CalculateLegacyComponentClocking to display extra information you can use to see how the clocking calculation is made.

Enumerator
LegacyComponentOrientationDisplayStyleNoDisplay 

No extra display.

LegacyComponentOrientationDisplayStyleDisplayCurveNormals 

Display the normal of each curve in the path.

LegacyComponentOrientationDisplayStyleDisplaySurface 

Display the surface swept along the curves in the path.

LegacyComponentOrientationDisplayStyleDisplayAll 

Display both the curve normals and surface.

Member Function Documentation

void NXOpen::Formboard::FormboardManager::AddPartAs3dHarness ( NXOpen::Part harnessPart)

Sets the input part as the part containing the potential harnesses to flatten.

This method will add the input part as a new component of this assembly if there is not already an instance of the input part in the work part assembly. This method is only necessary if the reference between the formboard and it's parent 3D harness assembly has been removed.

Passing in NULL for the harness part will sever the link between the formboard and it's current 3D harness part file.


Created in NX7.5.0.

License requirements : routing_harness ("Routing Harness")

Parameters
harnessPartPart containing the harnesses to flatten into this part.
void NXOpen::Formboard::FormboardManager::CalculateLegacyComponentClocking ( NXOpen::Assemblies::Component component1,
NXOpen::Assemblies::Component component2,
NXOpen::Formboard::FormboardManager::LegacyComponentOrientationDisplayStyle  displayStyle,
NXOpen::Vector3d rotationVector,
double *  clockingAngle,
NXOpen::Formboard::FormboardManager::LegacyComponentOrientationConfidenceLevel confidenceLevel 
)

Calculates the clocking or twist between the two components along their connecting path.

The FormboardManager::CalculateLegacyComponentClocking method uses an algorithm similar to the V1 formboard clocking calculated automatically when Routing created a formboard to find the clocking angle between two components.

First, it finds a vector representing the "up" direction on the first component.

The "up" direction is the multiport's rotate vector. If the multiport has no rotate vector, it uses the Z direction of the multiport's part.

Then, it sweeps this vector along the segments in the path connecting the two components.

Finally, it measures the angle between the swept vector and the second component's "up" vector. This angle is the clocking angle.

Throws an error if the component has no multiport or there is no path connecting the two components.


Created in NX11.0.2.

License requirements : routing_harness ("Routing Harness")

Parameters
component1The first component. The clocking of the second component is always relative to the rotation vector of the first component.
component2The second component. The clocking of the second component is always relative to the rotation vector of the first component.
displayStyleVarious options for displaying the curve normals, surfaces, etc. Useful for debugging or explaining the results.
rotationVectorThe rotation vector normal to the curve at the location of the second component's multiport.
clockingAngleThe relative angle between the rotation vector and the second component's multiport's rotate vector.
confidenceLevelHigh, medium, or low confidence reflecting how many branches the path traversed or whether or not the swept surfaces had problems.
NXOpen::Formboard::FaceAnnotationBuilder* NXOpen::Formboard::FormboardManager::CreateFaceAnnotationBuilder ( )

Creates a NXOpen::Formboard::FaceAnnotationBuilder object for importing CGM or Pattern file geometry and placing it on a drawing sheet or model view.

Returns

Created in NX7.5.0.

License requirements : routing_harness ("Routing Harness")
NXOpen::Formboard::FlipComponentBuilder* NXOpen::Formboard::FormboardManager::CreateFlipComponentBuilder ( )

Creates a NXOpen::Formboard::FlipComponentBuilder object for flipping of formboard component about an axis orthogonal to Z axis to ensure that after flipping component lies in XY plane.

Returns

Created in NX7.5.0.

License requirements : routing_harness ("Routing Harness")
NXOpen::Formboard::FormboardLayoutBuilder* NXOpen::Formboard::FormboardManager::CreateLayoutBuilder ( )

Creates a NXOpen::Formboard::FormboardLayoutBuilder that can flatten and layout new formboard geometry, or modify the layout of existing formboard geometry.

Returns

Created in NX7.5.0.

License requirements : routing_harness ("Routing Harness")
NXOpen::Formboard::ObjectAttributeReferenceBuilder* NXOpen::Formboard::FormboardManager::CreateObjectAttributeReferenceBuilder ( )

Creates a NXOpen::Formboard::ObjectAttributeReferenceBuilder that creates a tabular note object which reads values from the single object selected by the user.

It also creates leader for the annotation associated with the object selected by user.

Returns

Created in NX7.5.0.

License requirements : routing_harness ("Routing Harness")
NXOpen::Formboard::OrientBranchBuilder* NXOpen::Formboard::FormboardManager::CreateOrientBranchBuilder ( )

Creates a NXOpen::Formboard::OrientBranchBuilder object for rotating branches in formboard about Z axis.

Returns

Created in NX7.5.0.

License requirements : routing_harness ("Routing Harness")
NXOpen::Formboard::PathLengthAnnotationBuilder* NXOpen::Formboard::FormboardManager::CreatePathLengthAnnotationBuilder ( NXOpen::Annotations::Annotation annotation)

Creates a NXOpen::Formboard::PathLengthAnnotationBuilder
Created in NX7.5.0.



License requirements : routing_harness ("Routing Harness")

Parameters
annotationThe Formboard Path Length annotation.
NXOpen::Formboard::ShapeSegmentBuilder* NXOpen::Formboard::FormboardManager::CreateShapeSegmentBuilder ( NXOpen::Routing::ISegment segment)

Creates a NXOpen::Formboard::ShapeSegmentBuilder that can shape formboard segments.

Returns

Created in NX7.5.0.

License requirements : routing_harness ("Routing Harness")
Parameters
segmentThe routing segment to shape.
NXOpen::Formboard::UpdateFormboardBuilder* NXOpen::Formboard::FormboardManager::CreateUpdateFormboardBuilder ( )

Creates a NXOpen::Formboard::UpdateFormboardBuilder that compares and updates formboard geometry to match a modified master 3D harness.

Returns

Created in NX7.5.0.

License requirements : routing_harness ("Routing Harness")
void NXOpen::Formboard::FormboardManager::GetFmbdPlaneConstraints ( NXOpen::NXObject fmbdPlane,
std::vector< NXOpen::Positioning::ComponentConstraint * > &  constraints 
)

Gets NXOpen::Positioning::ComponentConstraint which are associated to the formboard plane.


Created in NX7.5.0.

License requirements : routing_harness ("Routing Harness")

Parameters
fmbdPlanefmbdplane
constraintsconstraints
void NXOpen::Formboard::FormboardManager::HideFormboardConstraints ( )

Hides the formboard constraints.


Created in NX7.5.0.

License requirements : routing_harness ("Routing Harness")

bool NXOpen::Formboard::FormboardManager::IsFormboard ( )

Returns whether or not the part containing this NXOpen::Formboard::FormboardManager is actually a Formboard Drawing part file.

Returns
whether or not the part is a formboard.
Created in NX7.5.0.

License requirements : routing_harness ("Routing Harness")
void NXOpen::Formboard::FormboardManager::ShowFormboardConstraints ( )

Shows all of the hidden formboard constraints.


Created in NX7.5.0.

License requirements : routing_harness ("Routing Harness")

void NXOpen::Formboard::FormboardManager::StoreHarnessesToFlatten ( const std::vector< NXOpen::Routing::Electrical::HarnessDevice * > &  harnesses)

Examines the input list of harnesses and stores information from the harnesses into the part containing this NXOpen::Formboard::FormboardManager .

The harnesses must from a sub-component of this part. The harnesses must form a fully-connected set of geometry. This method does not actually flatten or copy the harness geometry.
Created in NX7.5.0.

License requirements : routing_harness ("Routing Harness")

Parameters
harnessesHarnesses to flatten into this part.
tag_t NXOpen::Formboard::FormboardManager::Tag ( ) const

Returns the tag of this object.


The documentation for this class was generated from the following file:
Copyright 2019 Siemens Product Lifecycle Management Software Inc. All Rights Reserved.